+++
title = "Community"
+++

This page attempts to explain how the Redox OS community is organised and helps you navigate it.
The headings are clickable to help you get to where you need to go.

We follow the [Rust Code Of Conduct](https://www.rust-lang.org/policies/code-of-conduct) for rules in all community/chat channels.

## [Announcements](https://matrix.to/#/#redox-announcements:matrix.org)

We do our announcements on the [Announcements](https://matrix.to/#/#redox-announcements:matrix.org) room, it's public and you don't need to login on Matrix to read it.

- #redox-announcements:matrix.org (Use this Matrix room address if you don't want to use the external Matrix link)

## [Chat](https://matrix.to/#/#redox-join:matrix.org)

Matrix is the official way to talk with Redox OS team and community (these rooms are English-only, we don't accept other languages because we don't understand them).

Matrix has several different clients. [Element](https://element.io/) is a commonly used choice, it works on web browsers, Linux, MacOSX, Windows, Android and iOS.

If you have problems with Element, try [Fractal](https://gitlab.gnome.org/World/fractal).

- Join the [Join Requests](https://matrix.to/#/#redox-join:matrix.org) room and send a message requesting for an invite to the Redox Matrix space (the purpose of this is to avoid spam and bots).
- #redox-join:matrix.org (Use this Matrix room address if you don't want to use the external Matrix link)

(We recommend that you leave the "Join Requests" room after your entry on Redox space)

If you want to have a big discussion in our rooms, you should use a Element thread, it's more organized and easy to keep track if more discussions happen on the same room.

You cand find more information on the [Chat](https://doc.redox-os.org/book/chat.html) page.

## [Discord](https://discord.gg/JfggvrHGDY)

We have a Discord server as an alternative for Matrix, open the #join-requests channel and send a message requesting to be a member (the purpose of this is to avoid spam and bots)

The Matrix messages are sent to Discord and vice-versa using a bot, but sometimes some Discord messages aren't sent to Matrix (if this happens to you join in our Matrix space above)

## [Summer of Code](/rsoc)

The **Redox Summer of Code** (RSoC) program runs annually when funding permits, and we may participate in other Summer of Code type programs.
An overview of our Summer of Code programs and our plans for this year can be found on the [RSoC](/rsoc) page.
Check out our [RSoC Proposal Guide](/rsoc-proposal-how-to) and [Project Suggestions](/rsoc-project-suggestions).

## [GitLab](https://gitlab.redox-os.org/redox-os/redox)

A slightly more formal way of communication with fellow Redox devs, but a little less quick and convenient like the chat. Submit an issue when you run into problems compiling or testing. Issues can also be used if you would like to discuss a certain topic: be it features, code style, code inconsistencies, minor changes and fixes, etc.

If you want to create an account, read the [Signing in to GitLab](https://doc.redox-os.org/book/signing-in-to-gitlab.html) page.

Once you create an issue don't forget to post the link on the Dev or Support rooms of the chat, because the GitLab email notifications have distractions (service messages or spam) and most developers don't left their GitLab pages open to receive desktop notifications from the web browser (which require a custom setting to receive issue notifications).

By doing this you help us to pay attention to your issues and avoid them to be accidentally forgotten.

If you have ready MRs (merge requests) you must send the links in the [MRs](https://matrix.to/#/#redox-mrs:matrix.org) room. To join this room, you will need to request an invite in the [Join Requests](https://matrix.to/#/#redox-join:matrix.org) room.

By sending a message in the room, your MR will not be forgotten or accumulate conflicts.

## [Lemmy](https://lemmy.world/c/redox)

Our alternative to Reddit, where we post news and community threads.

## [Reddit](https://www.reddit.com/r/Redox/)

If you want a quick look at what's going on and talk about it.

[reddit.com/r/rust](https://www.reddit.com/r/rust) for related Rust news and discussions.

## [Fosstodon](https://fosstodon.org/@redox)

Our alternative to Twitter, where we post news and community threads.

## [Twitter](https://twitter.com/redox_os)

News and community threads.

## [YouTube](https://www.youtube.com/@RedoxOS)

Demos and board meetings.

## [Forum](https://discourse.redox-os.org/)

This is our archived forum with old/classic questions, it's inactive and can only be used for archival purposes. If you have a question, send on Matrix chat.

## [Talks](/talks/)

Redox talks given at various events and conferences.

## Spread the word

Community outreach is an important part of Redox's success. If more people know about Redox, then more contributors are likely to step in, and everyone can benefit from their added expertise. You can make a difference by writing articles, talking to fellow OS enthusiasts, or looking for communities that would be interested in knowing more about Redox.
