+++
title = "Communauté"
+++

Cette page tente d'expliquer comment la communauté Redox OS est organisée et vous aide à la naviguer.

Nous suivons le [Code de conduite de Rust](https://www.rust-lang.org/policies/code-of-conduct) pour les règles dans tous les salons de chat/de la communauté.

## [Annonces](https://matrix.to/#/#redox-announcements:matrix.org)

Nous faisons nos annonces sur [ce salon](https://matrix.to/#/#redox-announcements:matrix.org) Matrix, il est publique et vous n'avez pas besoin de vous connecter à Matrix pour le lire.

- #redox-announcements:matrix.org (Utilisez cette adresse de salon Matrix si vous ne souhaitez pas utiliser le lien Matrix externe)



## [Chat](https://matrix.to/#/#redox-join:matrix.org)

Matrix est la plateforme officielle pour communiquer avec l'équipe et la communautée de Redox OS (ces salons sont uniquement en anglais, nous n'acceptons pas d'autres langues car nous ne les comprenons pas).

Matrix possède de multiples clients. [Element](https://element.io/) est le choix le plus courant, il fonctionne sur les navigateurs Web, Linux, MacOSX, Windows, Android et iOS.

Si vous rencontrez des problèmes avec Element, essayez [nheko](https://nheko-reborn.github.io/).

- Rejoignez [ce salon](https://matrix.to/#/#redox-join:matrix.org) et n'oubliez pas de demander une invitation à l'espace Redox.
- #redox-join:matrix.org (Utilisez cette adresse de salon Matrix si vous ne souhaitez pas utiliser le lien Matrix externe)

(Nous vous recommandons de quitter le salon "Join Requests" après votre entrée sur l'espace Redox)

Si vous souhaitez avoir une grande discussion dans nos salons, vous devez utiliser un fil de discussion Element, il est plus organisé et plus facile à suivre si d'autres discussions ont lieu dans le même salon.

Vous pouvez trouver plus d'informations sur [cette page](https://doc.redox-os.org/book/chat.html).

## [Summer of Code](/rsoc)

Le programme **Redox Summer of Code** (RSoC) se déroule chaque année lorsque le financement le permet, et nous pouvons participer à d'autres évènements similaires.
Un aperçu de nos programmes Summer of Code et de nos projets pour cette année sont [ici](/rsoc).
Consultez notre [Guide de proposition RSoC](/rsoc-proposal-how-to) et nos [Suggestions de projet](/rsoc-project-suggestions).

## [GitLab](https://gitlab.redox-os.org/redox-os/redox)

Un moyen de communication un peu plus formel avec les autres développeurs de Redox, mais un peu moins rapide et pratique que le chat. Soumettez une Issue lorsque vous rencontrez des problèmes de compilation ou de tests. Une Issue peut aussi être ouverte si vous souhaitez simplement discuter d'un sujet en particulier, qu'il s'agisse de fonctionnalités, de style de code, d'incohérences de code, de modifications et de correctifs mineurs, etc.

Si vous souhaitez créer un compte, lisez cette [page](https://doc.redox-os.org/book/signing-in-to-gitlab.html).

Si vous avez des MRs prêts (merge requests), vous devez envoyer les liens sur le salon [MRs](https://matrix.to/#/#redox-mrs:matrix.org). Pour rejoindre ce salon, une vous aurez besoin de demander un invitation dans le salon [Join Requests](https://matrix.to/#/#redox-join:matrix.org).

De cette façon, en envoyant un message dans le salon, votre MR ne sera pas oublié et n’accumulera pas de conflits.

## [Lemmy](https://lemmy.world/c/redox)

Notre alternative à Reddit, où nous publions des actualités et des fils de discussion communautaires.

## [Reddit](https://www.reddit.com/r/Redox/)

Si vous voulez un aperçu rapide de ce qui se passe et en parler.

[reddit.com/r/rust](https://www.reddit.com/r/rust) pour des nouvelles et des discussions sur Rust.

## [Fosstodon](https://fosstodon.org/@redox)

Notre alternative à Twitter, où nous publions des nouvelles et des fils de discussion communautaires.


## [Twitter](https://twitter.com/redox_os)

Nouvelles et fils de la communauté.

## [YouTube](https://www.youtube.com/@RedoxOS)

Démos et réunions du conseil d'administration.

## [Forum](https://discourse.redox-os.org/)

Ceci est l'archive de notre forum avec des questions anciennes/classiques, il est inactif et doit être utilisé à des fins historiques. Si vous avez une question, envoyez-la sur le chat Matrix.

## [Conférences](/talks/)

Conférences de Redox réalisées à différents événements.

## Faites passer le message

Développer la communauté est un élément important du succès de Redox. Si davantage de personnes connaissent Redox, davantage de contributeurs sont susceptibles d'intervenir et tout le monde peut bénéficier de leur expertise supplémentaire. Vous pouvez faire la différence en écrivant des articles, en discutant avec d'autres passionnés de système d'exploitation ou en recherchant des communautés qui souhaiteraient en savoir plus sur Redox.
