+++
title = "Comunidade"
+++

Essa página explica como a comunidade do Redox OS é organizada e como você pode acessar ela.

Nós seguidos o [Código de Conduta da Rust](https://www.rust-lang.org/policies/code-of-conduct) como regra em todos os nossos canais de comunidade/chats.

## [Novidades](https://matrix.to/#/#redox-announcements:matrix.org)

Nós anunciamos as novidades do Redox OS nesta sala do Matrix, ela é pública e você pode ler sem um login no Matrix.

- #redox-announcements:matrix.org (Use esse endereço de sala do Matrix caso não queira utilizar o link externo do Matrix)

## [Chat](https://matrix.to/#/#redox-join:matrix.org)

Matrix é a forma de comunicação oficial com o time/comunidade do Redox OS (aceitamos apenas o Inglês nestas salas, pois não entendemos outras linguagens).

A rede Matrix tem diferentes clientes, sendo o [Element](https://element.io/) o mais utilizado.

O Element funciona em navegadores web, Linux, MacOSX, Windows, Android e iOS.

Caso tenha problemas com o Element, teste o [Fractal](https://gitlab.gnome.org/World/fractal).

- Entre na sala [Join Requests](https://matrix.to/#/#redox-join:matrix.org) e envie uma mensagem solicitando um convite para o espaço do Redox (o propósito disso é para evitar spam e bots).
- #redox-join:matrix.org (Use esse endereço de sala do Matrix caso não queira utilizar o link externo do Matrix)

(Nós recomendamos que você saia da sala "Join Requests" depois de entrar no espaço do Redox)

Caso você tenha uma grande discussão nas nossas salas, você deve usar um thread do Element, pois é mais organizado e fácil de acompanhar caso mais discussões ocorram na mesma sala.

Você pode encontrar mais informações na página [Chat](https://doc.redox-os.org/book/chat.html).

## [Discord](https://discord.gg/JfggvrHGDY)

Nós temos um servidor no Discord como alternativa ao Matrix, abra o canal #join-requests e envie uma mensagem pedindo para ser um membro (o propósito disso é para evitar spam e bots)

As mensagens do Matrix são enviadas para o Discord e vice-versa utilizando um bot, mas as vezes algumas mensagens do Discord não são enviadas pro Matrix (caso isso acontença com você, entre no nosso espaço do Matrix)

## [Summer of Code](/rsoc)

O programa **Redox Summer of Code** (RSoC) é relizado anualmente quando as doações permitem e nós podemos participar de outros programas do mesmo tipo.

Um resumo dos nossos programas Summer of Code e nossos planos para esse ano estão na página [RSoC](/rsoc).

Veja nosso [guia de proposta RSoC](/rsoc-proposal-how-to) e [sugestões de projeto](/rsoc-project-suggestions).

## [GitLab](https://gitlab.redox-os.org/redox-os/redox)

Uma forma mais formal de comunicação com os desenvolvedores do Redox, porém mais lento e menos conveniente de conversar.

Envie uma Issue se você tiver problemas compilando/testando ou apenas queira discutir algum assunto, seja funções, estilo de código, inconsistências de código, pequenas mudanças ou correções.

Se você quiser criar uma conta, leia a página [Signing in to GitLab](https://doc.redox-os.org/book/signing-in-to-gitlab.html).

Assim que você criar uma issue não se esqueça de postar o link nas salas "Dev" ou "Support" do chat, por que as notificações de email do GitLab possuem distrações (mensagens de serviço e spam) e a maioria dos programadores não deixam suas páginas do GitLab abertas no navegador web (que requer uma configuração customizada para receber notificações de issues).

Fazendo isso você nos ajuda a prestar atenção nas suas issues e evita que elas sejam esquecidas acidentalmente.

Se você tiver MRs (merge requests) prontos você precisa enviar o link deles na sala [MRs](https://matrix.to/#/#redox-mrs:matrix.org), antes de entrar nesta sala você precisa solicitar um convite para o espaço Matrix na sala [Join Requests](https://matrix.to/#/#redox-join:matrix.org).

Dessa forma seu MR não será esquecido, evitando conflitos.

## [Lemmy](https://lemmy.world/c/redox)

Nossa alternativa ao Reddit, postamos notícias e tópicos da comunidade.

## [Reddit](https://www.reddit.com/r/Redox/)

Caso queira ver as novidades e discutir sobre.

[reddit.com/r/rust](https://www.reddit.com/r/rust) - Para notícias relacionadas a Rust e discussões.

## [Fosstodon](https://fosstodon.org/@redox)

Nossa alternativa ao Twitter, postamos notícias e tópicos da comunidade.

## [Twitter](https://twitter.com/redox_os)

Notícias e tópicos da comunidade.

## [YouTube](https://www.youtube.com/@RedoxOS)

Demonstrações e reuniões da mesa diretora.

## [Fórum](https://discourse.redox-os.org/)

Nosso fórum histórico com perguntas clássicas/antigas, está inátivo e deve ser usado para consulta histórica.

Se você tem uma pergunta, faça no chat Matrix.

## [Palestras](/talks/)

Palestras sobre o Redox em diversos eventos e conferências.

### Nota

A divulgação da comunidade é uma parte importante no sucesso do Redox, quanto mais pessoas souberem sobre o Redox, mais contribuições podem vir e todos podem se beneficiar.

Você pode fazer a diferença escrevendo artigos, conversando com entusiastas de sistemas operacionais ou procurando por comunidades que podem estar interessadas em conhecer o Redox.
