+++
title = "Redox OS elects its first Board of Directors"
author = "Jeremy Soller"
date = "2023-06-21"
+++

On June 21, 2023, the Redox OS nonprofit elected its first Board of Directors.
The Redox OS project is a Unix-like operating system written in Rust, and
intended for free public and commercial use. The nonprofit was formed to
support the project and its community, and will help provide transparency in
the management of funds, hopefully leading to increased donations and the
ability to hire full-time staff.

The Redox OS Board of Directors consists of:

<hr>

### Ron Williams, as President

<a href="/img/board/ron-williams.jpg"><img width=256 height=256 src="/img/board/ron-williams.jpg"/></a>

Ron has over 30 years experience in the software industry in technical, consulting and executive roles. He has consulted to Fortune 500 companies in designing and developing new products. As president and co-founder of Ensemble Systems, he grew the company to over 100 technical staff, with Ensemble twice being selected as one of the best places to work in British Columbia. After many years as a consultant and executive, he has rediscovered his love of coding by contributing to Redox OS.

<hr>

### Jeremy Soller, as Treasurer and Vice-President

<a href="/img/board/jeremy-soller.jpg"><img width=256 height=256 src="/img/board/jeremy-soller.jpg"/></a>

Jeremy created the Redox OS project in 2015, and is the Redox [BDFL](https://en.wikipedia.org/wiki/Benevolent_dictator_for_life). He has been involved with open source software development for over fifteen years, starting with hobby projects and soon moving into professional open source software development. He is currently employed as Principal Engineer at System76, where he manages a team of engineers building open source software, firmware, and hardware. His experience with low-level development has driven many successful projects at both Redox OS and System76.

<hr>

### Alberto Souza, as Secretary

<a href="/img/board/alberto-souza.jpg"><img width=256 height=256 src="/img/board/alberto-souza.jpg"/></a>

Alberto has been an open-source activist and amateur systems researcher since 2017. He has used dozens of Unix-like systems and thousands of free and open-source programs, from mainstream to underground. He has been following Redox OS development over the years, feeling confident to start contributing in 2023. Since starting, he has made vast improvements to the Redox OS management, documentation and worked on porting numerous programs.

<hr>

### Discussion

Feel free to discuss this on social media:

- [Patreon](https://www.patreon.com/posts/84927623), help us by providing funding!
- [Lemmy](https://lemmy.world/post/397986)
- [Mastodon @redox](https://fosstodon.org/@redox/110584297927846238)
- [Mastodon @soller](https://fosstodon.org/@soller/110584297023639320)
- [Matrix](https://matrix.to/#/#redox-general:matrix.org), for new members go to the [join requests room](https://matrix.to/#/#redox-join:matrix.org)
- [Reddit r/redox](https://www.reddit.com/r/Redox/comments/14fju3d/redox_os_elects_its_first_board_of_directors/)
- [Twitter @redox_os](https://twitter.com/redox_os/status/1671629242197770240)
- [Twitter @jeremy_soller](https://twitter.com/jeremy_soller/status/1671629284233060352)
