+++
title = "Redox OS Summer of Code"
+++

Announcing Redox Summer of Code for 2025! This summer, we have a small number of positions open for students or recent graduates.
You must be a skilled Rust programmer, have experience with low-level programming and be an Open Source contributor.

You should propose a project that will take you approximately 8 weeks of full-time work to complete.
You are expected to check in your code to GitLab regularly, to provide regular progress reports, and a final technical report in the form of a News post.
Some project suggestions are included on the [RSoC Project Suggestions](/rsoc-project-suggestions/) page, but you can come up with your own proposal if you wish.

The application process is informal.
Please post a message in the [Summer of Code room](https://matrix.to/#/#redox-soc:matrix.org) indicating your interest and a description of what you hope to accomplish.

The Redox OS Summer of Code program is the primary use of donations to the Redox OS
project. 

We also participate in other Summer of Code type programs, when available,
which may have their own rules and criteria.
This year, we do not have any specific plans for other Summer of Code programs.

Have a look at our [Proposal Guidelines](/rsoc-proposal-how-to) and [Project Suggestions](/rsoc-project-suggestions).

## Previous contributions

(Add new project reports on the top of the following list)

- [Dynamic Linking - part 2](https://www.redox-os.org/news/02_rsoc2024_dynamic_linker/)
- [Dynamic Linking - part 1](https://www.redox-os.org/news/01_rsoc2024_dynamic_linker/)
- [on-demand paging - part 2](https://www.redox-os.org/news/kernel-9)
- [on-demand paging - part 1](https://www.redox-os.org/news/kernel-8)
- [Revirt-U](https://www.redox-os.org/news/rsoc-2023-eny-1)
- [QEMU on Redox - part 1](https://www.redox-os.org/news/rsoc-2021-qemu-1/)
- [QEMU on Redox - part 2](https://www.redox-os.org/news/bochs-qemu-2/)
- [Revirt - part 2](https://www.redox-os.org/news/rsoc-2022-revirt-u-1/)
- [Revirt - part 1](https://www.redox-os.org/news/revirt-1/)
- [Summer of Code Wrap-up 2023](https://www.redox-os.org/news/rsoc-2023-wrapup/)
- [VirtIO - part 2](https://www.redox-os.org/news/rsoc-virtio-2)
- [VirtIO - part 1](https://www.redox-os.org/news/rsoc-virtio-1)
- [Improving drivers and kernel - part 8](https://www.redox-os.org/news/drivers-and-kernel-7/)
- [Improving drivers and kernel - part 7](https://www.redox-os.org/news/drivers-and-kernel-6/)
- [Improving drivers and kernel - part 6](https://www.redox-os.org/news/io_uring-5/)
- [Improving drivers and kernel - part 5](https://www.redox-os.org/news/io_uring-4/)
- [Improving drivers and kernel - part 4](https://www.redox-os.org/news/io_uring-3/)
- [Improving drivers and kernel - part 3](https://www.redox-os.org/news/io_uring-2/)
- [Improving drivers and kernel - part 2](https://www.redox-os.org/news/io_uring-1/)
- [Improving drivers and kernel - part 1](https://www.redox-os.org/news/io_uring-0/)
- [Porting GDB to Redox - part 3](https://www.redox-os.org/news/public-announcement-gdb/)
- [Porting GDB to Redox - part 2](https://www.redox-os.org/news/rsoc-gdb-1/)
- [Porting GDB to Redox - part 1](https://www.redox-os.org/news/rsoc-gdb-0/)
- [Improving Ion UX - part 4](https://www.redox-os.org/news/rsoc-ion-ux-4-5/)
- [Improving Ion UX - part 3](https://www.redox-os.org/news/rsoc-ion-ux-3/)
- [Improving Ion UX - part 2](https://www.redox-os.org/news/rsoc-ion-ux-2/)
- [Improving Ion UX - part 1](https://www.redox-os.org/news/rsoc-ion-ux-1/)
- [Implementing ptrace - part 9](https://www.redox-os.org/news/rsoc-ptrace-8/)
- [Implementing ptrace - part 8](https://www.redox-os.org/news/rsoc-ptrace-7/)
- [Implementing ptrace - part 7](https://www.redox-os.org/news/rsoc-ptrace-6/)
- [Implementing ptrace - part 6](https://www.redox-os.org/news/rsoc-ptrace-5/)
- [Implementing ptrace - part 5](https://www.redox-os.org/news/rsoc-ptrace-4/)
- [Implementing ptrace - part 4](https://www.redox-os.org/news/rsoc-ptrace-3/)
- [Implementing ptrace - part 3](https://www.redox-os.org/news/rsoc-ptrace-2/)
- [Implementing ptrace - part 2](https://www.redox-os.org/news/rsoc-ptrace-1/)
- [Implementing ptrace - part 1](https://www.redox-os.org/news/rsoc-ptrace-0/)
- [Ion as a library - part 5](https://www.redox-os.org/news/rsoc-ion-lib-4/)
- [Ion as a library - part 4](https://www.redox-os.org/news/rsoc-ion-lib-3/)
- [Ion as a library - part 3](https://www.redox-os.org/news/rsoc-ion-lib-2/)
- [Ion as a library - part 2](https://www.redox-os.org/news/rsoc-ion-lib-1/)
- [Ion as a library - part 1](https://www.redox-os.org/news/rsoc-ion-lib-0/)
- [Relibc - Wrap Up](https://www.redox-os.org/news/rsoc-relibc-final/)
- [Relibc](https://www.redox-os.org/news/rsoc-relibc/)
- [Porting Redox to ARM64 - part 1](https://www.redox-os.org/news/rsoc-arm64-0x01/)
- [Implementing the FAT32 filesystem - part 3](https://www.redox-os.org/news/rsoc-fat32-3/)
- [Implementing the FAT32 filesystem - part 2](https://www.redox-os.org/news/rsoc-fat32-2/)
- [Implementing the FAT32 filesystem - part 1](https://www.redox-os.org/news/rsoc-fat32-1/)
- [Porting tokio to Redox - part 4](https://www.redox-os.org/news/rsoc-porting-tokio-4/)
- [Porting tokio to Redox - part 3](https://www.redox-os.org/news/rsoc-porting-tokio-3/)
- [Porting tokio to Redox - part 2](https://www.redox-os.org/news/rsoc-porting-tokio-2/)
- [Porting tokio to Redox - part 1](https://www.redox-os.org/news/rsoc-porting-tokio-1/)
